
#![allow(dead_code)]

use cfg_if::cfg_if;

mod ext;
use ext::*;

mod error;
use error::{
    WrapErrExt as _,
    WrapExt as _,
};
mod consts;
mod util;
mod hash;
mod metadata;
mod resolve;
mod database;

fn inner() -> Result<(), error::ErrorStack>
{
    Err(error!("constructing an error"))?;
    Ok(())
}

fn outer() -> Result<(), error::ErrorStack>
{
    inner().wrap_err("propagating an error")?;
    Ok(())
}

async fn begin() -> Result<i32, error::ErrorStack>
{
    outer().wrap_err("outer failed").wrap_err("outer failed twice!")?;
    Ok(0)
}

#[tokio::main]
async fn main() {
    std::process::exit(match begin().await {
	Ok(0) => return,
	Err(err) => {
	    eprintln!("\nexited with error: {}", err.short_message());
	    println!("\n{}", err);
	    1
	},
	Ok(v) => v
    })
}
